; EXTERNS

EXTERN DbgPrint:PROC

;
; Data section
;
.DATA
cpusig BYTE 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

;
; Code section
;
.CODE

_VmFailInvalid PROC
    pushfq              ; save RFLAGS 
    pop rax             ; store RFLAGS in RAX 
    xor rcx, rcx        ; rcx = 0
    bt eax, 0           ; RFLAGS.CF
    adc cl, cl          ; cl = cl + cl + RFLAGS.CF => 0 + 0 + RFLAGS.CF
    mov rax, rcx        ; rax <- rcx
    ret                 ; return rax as value to caller
_VmFailInvalid ENDP


_Cr4 PROC
    mov        rax, cr4    ; rax <- cr4
    ret                    ; return rax as value to caller (i.e., cr4 value)
_Cr4 ENDP


_SetCr4 PROC 
    mov rax,cr4            ; rax <- cr4
    or  rcx,rax            ; rcx |= rax
    mov cr4,rcx            ; cr4 <- rcx
    ret                    ; 
_SetCr4 ENDP

_VmxOn PROC
    push rcx                 ; push arg0
    mov rax, rsp             ; rax <- rsp => so rax = arg0
    vmxon qword ptr [rax]    ; rax points to a physical addr
    pop rcx                  ; fix stack
    ret                      ;
_VmxOn ENDP

_VmxOff PROC
    vmxoff              ; turn vmx off
    mov rsp, rdx        ; rsp <- rdx
    push rcx            ; tos = rcx
    ret                 ; 
_VmxOff ENDP

_ReadMsr PROC
;    xor        rax, rax
    rdmsr                ; MSR.index(ecx) -> edx:eax
    shl        rdx, 32
    or        rax, rdx
    ret
_ReadMsr ENDP

_MyCpuid PROC

    ;; preserve all (overkill?) non-volatile regs
    push rbx
    push rbp
    push rdi
    push rsi
    push r12
    push r13
    push r14
    push r15

    xor eax, eax
    cpuid
    lea rax, cpusig
    mov [rax+0], ebx    
    mov [rax+4], edx
    mov [rax+8], ecx
    lea rax, cpusig
    

    pop r15
    pop r14
    pop r13
    pop r12
    pop rsi
    pop rdi
    pop rbp
    pop rbx

    ret

_MyCpuid ENDP



END